/*

This file is part of the Physical Audio Digital Filters (PADF)

PADF can be obtained at http://stefanofasciani.com/padf.html
TSAM Copyright (C) 2017 Stefano Fasciani, University of Wollongong
Inquiries: stefanofasciani@stefanofasciani.com

The PADF is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

The PADF is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Less General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with TSAM. If not, see <http://www.gnu.org/licenses/>.

If you use the PADF or any part of it in any program or publication, please acknowledge its authors by adding a reference to this pubblication:

S. Fasciani, 2017, "Pysical Audio Digital Filters" in proceedings of the 17th Conference on New Interfaces for Musical Expression, Copenhagen, Denmark

*/

inlets = 1;
outlets = 2;

var whitein = new Buffer("whitein");
var whiteout = new Buffer("whiteout");


function bang() {
	var framecount = (whitein.framecount() -1);
	var zero_in = whitein.peek(1, 0, 1);
	var zero_out = whiteout.peek(1, 0, 1);
	var buffer_in = whitein.peek(1, 1, framecount);
	var buffer_out = whiteout.peek(1, 1, framecount);
	var acc_in = 0;
	var acc_out = 0;

	for (var i=0; i<framecount; ++i) {
		var sample_in = buffer_in[i];
		var acc_in = acc_in + (sample_in * sample_in);
		var sample_out = buffer_out[i];
		var acc_out = acc_out + (sample_out * sample_out);
	}
	
	var output_in = (acc_in/(zero_in*zero_in));
	var output_out = (acc_out/(zero_out*zero_out));
	
	outlet(0, output_in);
	outlet(1, output_out);
}
